using System;
using System.Collections;

namespace com.macromedia.mesh.collections
{
	public class StringArrayList : CollectionBase
	{
		protected Type classType;
		protected const string className = "System.String";

		public StringArrayList()
		{
			classType = Type.GetType(className);
		}

		public String this[ int index ]  
		{
			get  
			{
				return( (String) List[index] );
			}
			set  
			{
				List[index] = value;
			}
		}

		public int Add( String value )  
		{
			return( List.Add( value ) );
		}

		public int IndexOf( String value )  
		{
			return( List.IndexOf( value ) );
		}

		public void Insert( int index, String value )  
		{
			List.Insert( index, value );
		}

		public void Remove( String value )  
		{
			List.Remove( value );
		}

		public bool Contains( String value )  
		{
			// If value is not of type String, this will return false.
			return( List.Contains( value ) );
		}

		protected void OnInsert( int index, string value )  
		{
			if ( !value.GetType().IsSubclassOf(classType))
				throw new ArgumentException( "Value must be of type " + classType.ToString(), "value" );
		}

		protected void OnRemove( int index, string value )  
		{
			if ( !value.GetType().IsSubclassOf(classType))
				throw new ArgumentException( "Value must be of type " + classType.ToString(), "value" );
		}

		protected void OnSet( int index, string oldValue, string newValue )  
		{
			if ( !(oldValue.GetType().IsSubclassOf(classType)) || !(newValue.GetType().IsSubclassOf(classType)))
				throw new ArgumentException( "Value must be of type " + classType.ToString(), "newValue" );
		}

		protected void OnValidate( string value )  
		{
			if ( !value.GetType().IsSubclassOf(classType))
				throw new ArgumentException( "Value must be of type " + classType.ToString() );
		}
	}
}
