using System;
using System.IO;
using System.Security;

namespace com.macromedia.mesh.log
{
	/// <summary>
	/// Summary description for Class1.
	/// </summary>
	public class FileLogger : StreamWriterLogger
	{
		private FileInfo logFile;
		private bool append;

		public FileLogger(string filePath, bool append)
		{
			this.append = append;
			LogFile = GetFile(filePath);
		}

		public FileInfo LogFile
		{
			get
			{
				return logFile;
			}
			set
			{
				logFile = value;
				StreamWriter = CreateFileStream(logFile);
			}
		}

		public FileInfo getLogFile()
		{
			return logFile;
		}

		//move this to utils?
		private FileInfo GetFile(string filePath)
		{

			FileInfo l = new FileInfo(filePath);

			if(!l.Directory.Exists)
			{
				try
				{
					l.Directory.Create();
				}
				catch(UnauthorizedAccessException uae)
				{
					throw new Exception("Could not create log file. The file name is a Directory.", uae);
				}
				catch(SecurityException se)
				{
					throw new Exception("Could not create log file. Permission denied.", se);
				}
				catch(Exception e)
				{
					throw new Exception("Could not create log file.", e);
				}
			}

			return l;
		}

		private StreamWriter CreateFileStream(FileInfo f)
		{
			if(append)
			{
				return f.AppendText();
			}
			else
			{
				return f.CreateText();
			}
		}
	}
}
